- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# aws_ssm_parameter_store – Manage key-value pairs in aws parameter store

New in version 2.5.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Manage key-value pairs in aws parameter store.

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- botocore
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
decryption boolean | Choices: no yes ← | Work with SecureString type to get plain text secrets
description - |  | parameter key description.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
key_id - | Default: "aws/ssm (this key is automatically generated at the first parameter created)." | aws KMS key to decrypt the secrets.
name - / required |  | parameter key name.
overwrite_value - added in 2.6 | Choices: never changed ← always | Option to overwrite an existing value if it already exists. String
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region - |  | region.
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: present ← absent | Creates or modifies an existing parameter Deletes a parameter
string_type - | Choices: String ← StringList SecureString | Parameter String type
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.
value - |  | Parameter value.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: Create or update key/value pair in aws parameter store
      aws_ssm_parameter_store:
        name: "Hello"
        description: "This is your first key"
        value: "World"

    - name: Delete the key
      aws_ssm_parameter_store:
        name: "Hello"
        state: absent

    - name: Create or update secure key/value pair with default kms key (aws/ssm)
      aws_ssm_parameter_store:
        name: "Hello"
        description: "This is your first key"
        string_type: "SecureString"
        value: "World"

    - name: Create or update secure key/value pair with nominated kms key
      aws_ssm_parameter_store:
        name: "Hello"
        description: "This is your first key"
        string_type: "SecureString"
        key_id: "alias/demo"
        value: "World"

    - name: Always update a parameter store value and create a new version
      aws_ssm_parameter_store:
        name: "overwrite_example"
        description: "This example will always overwrite the value"
        string_type: "String"
        value: "Test1234"
        overwrite_value: "always"

    - name: recommend to use with aws_ssm lookup plugin
      debug: msg="{{ lookup('aws_ssm', 'hello') }}"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
delete_parameter dictionary | success | Delete a parameter from the system.
put_parameter dictionary | success | Add one or more parameters to the system.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Nathan Webster (@nathanwebsterdotme)
- Bill Wang (@ozbillwang) <ozbillwang@gmail.com>
- Michael De La Rue (@mikedlr)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.